

#if defined(__STDC__) || defined(__cplusplus)
#ifndef __
#define __(a) a
#endif
#else
#ifndef __
#define __(a) ()
#endif
#endif


#define MIBHASHSIZE   67


typedef struct _mibNode MIBNODE;
typedef struct _mibHash MIBHASH;


/* MIB Types */

struct _mibHash
{
        MIBHASH *next;
        MIBNODE *contents;
};


struct _mibNode
{
	char *name;
	MIBNODE *father;
	MIBNODE *brother;
	MIBNODE *child1;
	long index;
	WORD type;
	WORD mode;
	WORD status;
};

/* internal MIB api */

int MibInitialise __((void));
MIBNODE *MibFindChild __((MIBNODE * fPtr, long index));
MIBNODE *MibFindNode __((char *name));
int MibAddNode __((MIBNODE * node, MIBNODE * fnode));
int MibFillID __((MIBNODE * node, long * id));
MIBNODE *MibFindID __((long * id, int nr));
MIBNODE *MibFindID2 __((long * id, int nr, int *nrmatched));
void MibDumpTree __((void));
void DumpTree __((char *name));
MIBNODE *MibCreateNode __((char *name, char *position));
MIBNODE *MibScanLine __((char *line));
int MibFindChunks __((char *line, char **chunks, int *clens));
int MibDecodeType __((char *type));
int MibDecodeMode __((char *mode));
int MibDecodeStatus __((char *status));
char *MibEncodeStatus __((int status));
char *MibEncodeMode __((int mode));
char *MibEncodeType __((int type));


int MibInit __((void));
int MibFullMib __((void));
int MibReadMib __((FILE * fp));
int MibName2ID __((long * id, char *name));
char *MibID2Name __((long * id, int nr, int *nrmatched, char *));
int MibIDType __((long * id, int nr));
int MibIDMode __((long * id, int nr));
int MibIDStatus __((long * id, int nr));
int MibIDInfo __((long * id, int nr, char *res));
int MibNameType __((char *name));
int MibNameMode __((char *name));
int MibNameStatus __((char *name));
char *MibGetFirstChild __((char *name));
char *MibGetNextChild __((char *name));

MIBNODE *MibResolveHash();

